varying vec3 g_Normal;
varying vec3 g_Position; 

uniform int   g_LightType;

uniform int g_HasDiffuseTexture;

uniform sampler2D g_DiffuseTexture;


void main (void)  
{     

	vec4 fragColor = gl_Color;

	if(g_HasDiffuseTexture == 1 )
	{
		vec4 color = texture2D(g_DiffuseTexture,gl_TexCoord[0].st);
		fragColor = fragColor * color;

	}

	float dotNormalLight = 0.0f;
	

	if( g_LightType == 1 ) // Directionnal
	{
		vec3 lightDir = gl_LightSource[0].position.xyz;
		dotNormalLight = max( dot( normalize( g_Normal ), normalize( lightDir ) ) , 0.0 ); 
	}
	else if( g_LightType == 2 ) // Local
	{
		vec3 lightDir = g_Position - gl_LightSource[0].position.xyz;
		dotNormalLight = max( dot( normalize( g_Normal ), normalize( -lightDir ) ) , 0.0 ); 
	}
	else if(  g_LightType == 3 ) // Spot
	{
		vec3 lightDir = g_Position - gl_LightSource[0].position.xyz;
		dotNormalLight = max( dot( normalize( g_Normal ), normalize( -lightDir ) ) , 0.0 );

		float spotEffect = dot(normalize(gl_LightSource[0].spotDirection), normalize(lightDir));
		if ( spotEffect > gl_LightSource[0].spotCosCutoff) 
		{
					dotNormalLight = dotNormalLight; 
		}
		else
		{
			dotNormalLight = 0.0f;
		}
	}
	else // No light
	{
		dotNormalLight = 1.0f;
	}
	
	fragColor = fragColor * dotNormalLight;
	

	gl_FragColor = fragColor;

}  
 

